#include "acm.h"


void canInitMessage(CanMessage * stMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1

    uint8_t iDataIndex = 0;

    for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
        stMessage->aData[iDataIndex] = 0;

    stMessage->bEid = 1;
    stMessage->bEnabled = 1;
    stMessage->bPending = 0;

    stMessage->bReading = 0;
    stMessage->bWriting = 0;

    stMessage->iDlc = 8;
    stMessage->iFilter = 0;
    stMessage->iId = 0;

    #endif

    return;
}
void can1AbortTx(int n)
{
	int i;
	for(i=0;i<11;i++)
		TIMER1_OUT[i] = 0;	
}
void can1AbortTx_acw_1(int n)
{
	int i;
	for(i=0;i<11;i++)
		TIMER1_OUT_ACW_1[i] = 0;	
}

void can1AbortTx_acw_2(int n)
{
	int i;
	for(i=0;i<11;i++)
		TIMER1_OUT_ACW_2[i] = 0;	
}

void ctInit(void)
{
    uint16_t iIndex = 0;

    // Set all message items within the RX message table to blank.
    for(iIndex = 0; iIndex < CAN_TABLE_RX_LENGTH; iIndex++)
        canInitMessage(&aCanTableRx[iIndex]);

    // Set all message items within the TX message table to blank.
    for(iIndex = 0; iIndex < CAN_TABLE_TX_LENGTH; iIndex++)
        canInitMessage(&aCanTableTx[iIndex]);

    // The dead message is returned when a valid message handle can't be found
    // in one of the tables.
    canInitMessage(&stDeadMessage);

    return;
}

// Set actual message
void ctSetMessage(CanMessage * stMessage, CanTable_Type_e eCanTable, uint16_t iTableIndex)
{
    uint8_t iDataIndex = 0;
    switch(eCanTable)
    {
        case CanTable_Receive:
        {
           if(iTableIndex < CAN_TABLE_RX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableRx[iTableIndex].bReading == 1)
                    break;

               if(aCanTableRx[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableRx[iTableIndex].bWriting = 1;
			   
				// Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableRx[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableRx[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableRx[iTableIndex].bEid = stMessage->bEid;
                aCanTableRx[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableRx[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableRx[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableRx[iTableIndex].iId = stMessage->iId;
                // Okay it's done
                aCanTableRx[iTableIndex].bWriting = 0;
                aCanTableRx[iTableIndex].bPending = 1;				
            }
            break;
        }

        case CanTable_Transmit:
        {
           if(iTableIndex < CAN_TABLE_TX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableTx[iTableIndex].bReading == 1)
                    break;

               if(aCanTableTx[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableTx[iTableIndex].bWriting = 1;

                // Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableTx[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableTx[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableTx[iTableIndex].bEid = stMessage->bEid;
                aCanTableTx[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableTx[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableTx[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableTx[iTableIndex].iId = stMessage->iId;

                // Okay it's done
                aCanTableTx[iTableIndex].bWriting = 0;
                aCanTableTx[iTableIndex].bPending = 1;
            }
            break;
        }
        default:
            break;
    }
    return;
}
void ctSetMessage_acw_1(CanMessage * stMessage, CanTable_Type_e eCanTable, uint16_t iTableIndex)
{
    uint8_t iDataIndex = 0;
    switch(eCanTable)
    {
        case CanTable_Receive:
        {
           if(iTableIndex < CAN_TABLE_RX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableRx_acw_1[iTableIndex].bReading == 1)
                    break;

               if(aCanTableRx_acw_1[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableRx_acw_1[iTableIndex].bWriting = 1;
			   
                // Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableRx_acw_1[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableRx_acw_1[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableRx_acw_1[iTableIndex].bEid = stMessage->bEid;
                aCanTableRx_acw_1[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableRx_acw_1[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableRx_acw_1[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableRx_acw_1[iTableIndex].iId = stMessage->iId;
				
                // Okay it's done
                aCanTableRx_acw_1[iTableIndex].bWriting = 0;
                aCanTableRx_acw_1[iTableIndex].bPending = 1;	
            }
            break;
        }

        case CanTable_Transmit:
        {
           if(iTableIndex < CAN_TABLE_TX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableTx_acw_1[iTableIndex].bReading == 1)
                    break;

               if(aCanTableTx_acw_1[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableTx_acw_1[iTableIndex].bWriting = 1;
			   
				// Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableTx_acw_1[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableTx_acw_1[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableTx_acw_1[iTableIndex].bEid = stMessage->bEid;
                aCanTableTx_acw_1[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableTx_acw_1[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableTx_acw_1[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableTx_acw_1[iTableIndex].iId = stMessage->iId;
				
                // Okay it's done
                aCanTableTx_acw_1[iTableIndex].bWriting = 0;
                aCanTableTx_acw_1[iTableIndex].bPending = 1;
            }
            break;
        }
        default:
            break;
    }
    return;
}

void ctSetMessage_acw_2(CanMessage * stMessage, CanTable_Type_e eCanTable, uint16_t iTableIndex)
{
    uint8_t iDataIndex = 0;
    switch(eCanTable)
    {
        case CanTable_Receive:
        {
           if(iTableIndex < CAN_TABLE_RX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableRx_acw_2[iTableIndex].bReading == 1)
                    break;

               if(aCanTableRx_acw_2[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableRx_acw_2[iTableIndex].bWriting = 1;
			   
                // Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableRx_acw_2[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableRx_acw_2[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableRx_acw_2[iTableIndex].bEid = stMessage->bEid;
                aCanTableRx_acw_2[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableRx_acw_2[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableRx_acw_2[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableRx_acw_2[iTableIndex].iId = stMessage->iId;
				
                // Okay it's done
                aCanTableRx_acw_2[iTableIndex].bWriting = 0;
                aCanTableRx_acw_2[iTableIndex].bPending = 1;	
            }
            break;
        }

        case CanTable_Transmit:
        {
           if(iTableIndex < CAN_TABLE_TX_LENGTH)
            {
               // Is the message in use by something else?  If so, GTFO
               if(aCanTableTx_acw_2[iTableIndex].bReading == 1)
                    break;

               if(aCanTableTx_acw_2[iTableIndex].bWriting == 1)
                    break;

               // Message is being written, don't try to read it
               aCanTableTx_acw_2[iTableIndex].bWriting = 1;
			   
				// Clear out the old CAN data fields.
                for(iDataIndex = 0; iDataIndex < 8; iDataIndex++)
                    aCanTableTx_acw_2[iTableIndex].aData[iDataIndex] = 0;

                // Copy the new data into the table.
                for(iDataIndex = 0; iDataIndex < stMessage->iDlc; iDataIndex++)
                    aCanTableTx_acw_2[iTableIndex].aData[iDataIndex] = stMessage->aData[iDataIndex];

                aCanTableTx_acw_2[iTableIndex].bEid = stMessage->bEid;
                aCanTableTx_acw_2[iTableIndex].bEnabled = stMessage->bEnabled;
                aCanTableTx_acw_2[iTableIndex].iDlc = stMessage->iDlc;
                aCanTableTx_acw_2[iTableIndex].iFilter = stMessage->iFilter;
                aCanTableTx_acw_2[iTableIndex].iId = stMessage->iId;
				
                // Okay it's done
                aCanTableTx_acw_2[iTableIndex].bWriting = 0;
                aCanTableTx_acw_2[iTableIndex].bPending = 1;
            }
            break;
        }
        default:
            break;
    }
    return;
}

// find message slot from table according to id
// Search the table for the CAN message ID and return the table index.  If
// the CAN message ID isn't found, the function returns an index that is out
// of range.
uint16_t ctGetMessageIndex(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint8_t bFoundId = 0;
    uint16_t iTableIndex = 0;

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_RX_LENGTH; iTableIndex++)	//CAN_TABLE_RX_LENGTH == 48
            {
                if(aCanTableRx[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_RX_LENGTH;
            }

            break;
        }

        case CanTable_Transmit:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_TX_LENGTH; iTableIndex++)
            {
                if(aCanTableTx[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_TX_LENGTH;
            }

            break;
        }

        default:
            break;
    }

    return iTableIndex;
}

uint16_t ctGetMessageIndex_acw_1(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint8_t bFoundId = 0;
    uint16_t iTableIndex = 0;

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_RX_LENGTH; iTableIndex++)	//CAN_TABLE_RX_LENGTH == 48
            {
                if(aCanTableRx_acw_1[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_RX_LENGTH;
            }

            break;
        }

        case CanTable_Transmit:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_TX_LENGTH; iTableIndex++)
            {
                if(aCanTableTx_acw_1[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_TX_LENGTH;
            }

            break;
        }

        default:
            break;
    }

    return iTableIndex;
}

uint16_t ctGetMessageIndex_acw_2(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint8_t bFoundId = 0;
    uint16_t iTableIndex = 0;

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_RX_LENGTH; iTableIndex++)	//CAN_TABLE_RX_LENGTH == 48
            {
                if(aCanTableRx_acw_2[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_RX_LENGTH;
            }

            break;
        }

        case CanTable_Transmit:
        {
            for(iTableIndex = 0; iTableIndex < CAN_TABLE_TX_LENGTH; iTableIndex++)
            {
                if(aCanTableTx_acw_2[iTableIndex].iId == iCanId)
                {
                    bFoundId = 1;
                    break;
                }
            }

            if(!bFoundId)
            {
                iTableIndex = CAN_TABLE_TX_LENGTH;
            }

            break;
        }

        default:
            break;
    }

    return iTableIndex;
}

uint32_t e15aerTtCanGetId(uint16_t iNodeAddress, uint8_t iCycleIndex, uint8_t iWindowIndex)
{
    TtCanWindow stWindow = aE15AerSchedule[iCycleIndex][iWindowIndex];//0,0
    uint32_t iReturn = 0;

    // Check the node address vs the window's address value.
    if(stWindow.iNodeAddress == iNodeAddress)
    {
        iReturn = stWindow.aMessageIds[stWindow.aMessageIds[0]];		//iReturn = 0x3200

        // Increment the array index and check for a terminator value.
        stWindow.aMessageIds[0]++;
        
        if(stWindow.aMessageIds[stWindow.aMessageIds[0]] == 0)
            stWindow.aMessageIds[0] = 1;
    }
    return iReturn;
}

// Retrieve a message by the CAN message ID.
CanMessage * ctGetMessageById(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint16_t iTableIndex = ctGetMessageIndex(eCanTable, iCanId);

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            if(iTableIndex < CAN_TABLE_RX_LENGTH)
                return &aCanTableRx[iTableIndex];

            break;
        }

        case CanTable_Transmit:
        {
            if(iTableIndex < CAN_TABLE_TX_LENGTH)
                return &aCanTableTx[iTableIndex];

            break;
        }

        default:
            break;
    }

    return &stDeadMessage;
}
CanMessage * ctGetMessageById_acw_1(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint16_t iTableIndex = ctGetMessageIndex_acw_1(eCanTable, iCanId);

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            if(iTableIndex < CAN_TABLE_RX_LENGTH)
                return &aCanTableRx_acw_1[iTableIndex];

            break;
        }

        case CanTable_Transmit:
        {
            if(iTableIndex < CAN_TABLE_TX_LENGTH)
                return &aCanTableTx_acw_1[iTableIndex];

            break;
        }

        default:
            break;
    }

    return &stDeadMessage;
}

CanMessage * ctGetMessageById_acw_2(CanTable_Type_e eCanTable, uint32_t iCanId)
{
    uint16_t iTableIndex = ctGetMessageIndex_acw_2(eCanTable, iCanId);

    switch(eCanTable)
    {
        case CanTable_Receive:
        {
            if(iTableIndex < CAN_TABLE_RX_LENGTH)
                return &aCanTableRx_acw_2[iTableIndex];

            break;
        }

        case CanTable_Transmit:
        {
            if(iTableIndex < CAN_TABLE_TX_LENGTH)
                return &aCanTableTx_acw_2[iTableIndex];

            break;
        }

        default:
            break;
    }

    return &stDeadMessage;
}
//Store CAN buffer(aCAN1BUFFER) contents into middle variable stMessage
void can1RxMessage(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1

    // Check the IDE bit to determine message ID length.
    if(aCAN1Buffer[iBufferIndex][0] & 0x01)
    {
        // This message has an extended length ID.
        stCanMessage->iId = ((uint32_t)aCAN1Buffer[iBufferIndex][0] & 0x1ffc) << 16;
        stCanMessage->iId |= (uint32_t)aCAN1Buffer[iBufferIndex][1] << 6;
        stCanMessage->iId |= ((uint32_t)aCAN1Buffer[iBufferIndex][2] & 0xfc00) >> 10;
        stCanMessage->bEid = 1;
    }
    else
    {
        // This message has a standard length ID.
        stCanMessage->bEid = 0;
        stCanMessage->iId = (aCAN1Buffer[iBufferIndex][0] >> 2);
    }

    // The length of the CAN ID does not affect the layout of the data buffers.
    // You know, I could probably turn this into a loop.
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer[iBufferIndex][3]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer[iBufferIndex][3] >> 8);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer[iBufferIndex][4]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer[iBufferIndex][4] >> 8);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer[iBufferIndex][5]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer[iBufferIndex][5] >> 8);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer[iBufferIndex][6] >> 8);
    stCanMessage->iDlc = (uint8_t)aCAN1Buffer[iBufferIndex][2] & 0x0f;
    stCanMessage->iFilter = (uint8_t)(aCAN1Buffer[iBufferIndex][7] >> 8);

    #endif

    return;
}
void can1RxMessage_acw_1(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1

    // Check the IDE bit to determine message ID length.
    if(aCAN1Buffer_acw_1[iBufferIndex][0] & 0x01)
    {
        // This message has an extended length ID.
        stCanMessage->iId = ((uint32_t)aCAN1Buffer_acw_1[iBufferIndex][0] & 0x1ffc) << 16;
        stCanMessage->iId |= (uint32_t)aCAN1Buffer_acw_1[iBufferIndex][1] << 6;
        stCanMessage->iId |= ((uint32_t)aCAN1Buffer_acw_1[iBufferIndex][2] & 0xfc00) >> 10;
        stCanMessage->bEid = 1;
    }
    else
    {
        // This message has a standard length ID.
        stCanMessage->bEid = 0;
        stCanMessage->iId = (aCAN1Buffer_acw_1[iBufferIndex][0] >> 2);
    }

    // The length of the CAN ID does not affect the layout of the data buffers.
    // You know, I could probably turn this into a loop.
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][3]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][3] >> 8);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][4]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][4] >> 8);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][5]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][5] >> 8);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][6] >> 8);
    stCanMessage->iDlc = (uint8_t)aCAN1Buffer_acw_1[iBufferIndex][2] & 0x0f;
    stCanMessage->iFilter = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][7] >> 8);

    #endif

    return;
}

void can1RxMessage_acw_2(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1

    // Check the IDE bit to determine message ID length.
    if(aCAN1Buffer_acw_2[iBufferIndex][0] & 0x01)
    {
        // This message has an extended length ID.
        stCanMessage->iId = ((uint32_t)aCAN1Buffer_acw_2[iBufferIndex][0] & 0x1ffc) << 16;
        stCanMessage->iId |= (uint32_t)aCAN1Buffer_acw_2[iBufferIndex][1] << 6;
        stCanMessage->iId |= ((uint32_t)aCAN1Buffer_acw_2[iBufferIndex][2] & 0xfc00) >> 10;
        stCanMessage->bEid = 1;
    }
    else
    {
        // This message has a standard length ID.
        stCanMessage->bEid = 0;
        stCanMessage->iId = (aCAN1Buffer_acw_2[iBufferIndex][0] >> 2);
    }

    // The length of the CAN ID does not affect the layout of the data buffers.
    // You know, I could probably turn this into a loop.
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][3]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][3] >> 8);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][4]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][4] >> 8);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][5]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][5] >> 8);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][6] >> 8);
    stCanMessage->iDlc = (uint8_t)aCAN1Buffer_acw_2[iBufferIndex][2] & 0x0f;
    stCanMessage->iFilter = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][7] >> 8);

    #endif

    return;
}

void directRxMessage(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1
	int i;
	stCanMessage->iId = id_acm;
	stCanMessage->bEid = 1;
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer[iBufferIndex][0]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer[iBufferIndex][1]);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer[iBufferIndex][2]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer[iBufferIndex][3]);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer[iBufferIndex][4]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer[iBufferIndex][5]);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer[iBufferIndex][7]);
    stCanMessage->iFilter = 0;
	if (id_acm == 0x3200)
		stCanMessage->iDlc = 1;
	else
		stCanMessage->iDlc = 8;
	for(i=0;i<8;i++)
		aCAN1Buffer[iBufferIndex][i] = 0;
    #endif

    return;
}

void directRxMessage_acw_1(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1
	int i;
	stCanMessage->iId = id_acw_1;
	stCanMessage->bEid = 1;
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][0]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][1]);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][2]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][3]);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][4]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][5]);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer_acw_1[iBufferIndex][7]);
    stCanMessage->iFilter = 0;
	if (id_acw_1 == 0x3200)
		stCanMessage->iDlc = 1;
	else
		stCanMessage->iDlc = 8;
	for(i=0;i<8;i++)
		aCAN1Buffer_acw_1[iBufferIndex][i] = 0;
    #endif

    return;
}

void directRxMessage_acw_2(uint8_t iBufferIndex, CanMessage * stCanMessage)
{
    #ifdef ENABLE_MODULE_ECAN_1
	int i;
	stCanMessage->iId = id_acw_2;
	stCanMessage->bEid = 1;
    stCanMessage->aData[0] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][0]);
    stCanMessage->aData[1] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][1]);
    stCanMessage->aData[2] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][2]);
    stCanMessage->aData[3] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][3]);
    stCanMessage->aData[4] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][4]);
    stCanMessage->aData[5] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][5]);
    stCanMessage->aData[6] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][6]);
    stCanMessage->aData[7] = (uint8_t)(aCAN1Buffer_acw_2[iBufferIndex][7]);
    stCanMessage->iFilter = 0;
	if (id_acw_2 == 0x3200)
		stCanMessage->iDlc = 1;
	else
		stCanMessage->iDlc = 8;
	for(i=0;i<8;i++)
		aCAN1Buffer_acw_2[iBufferIndex][i] = 0;
    #endif

    return;
}

// Check for boundary violations and set data in the servo struct.
void servo_mwSetPosition(ServoData * stServoData, uint16_t iPosition)
{
    if(stServoData->bEnabled != 1)
        return;

    // ************************************************************************
    // Store the target position irrespective of the servo limits.
    stServoData->iPosTarget = iPosition;

    // Catch and flag requests for positions that are beyond limits.
    if(stServoData->iPosMin > iPosition)
    {
        // The position is below the servo's minimum limit.
        iPosition = stServoData->iPosMin;
        stServoData->bLimitViolation = 1;
    }
    else
        stServoData->bLimitViolation = 0;

    if(stServoData->iPosMax < iPosition)
    {
        // The position is above the servo's maximum limit.
        iPosition = stServoData->iPosMax;
        stServoData->bLimitViolation = 1;
    }
    else
        stServoData->bLimitViolation = 0;

    stServoData->iPosPrevious = stServoData->iPosCurrent;
    stServoData->iPosCurrent = iPosition;

    // ************************************************************************
    // If the servo position changed, it must be moving.
    if(stServoData->iPosPrevious != stServoData->iPosCurrent)
    {
        stServoData->bMoving = 1;
        stServoData->iTickSinceLastMove = 0;
    }
    else
        stServoData->bMoving = 0;

    return;
}
// Return a pointer to the sensor data struct.
AcmSensorData * acmSensorRet(void)
{
    return &stAcmSensor;
}

// Return a pointer to the servo data array.
ServoData * acmServoRet(void)
{
    return aAcmServo;
}

uint8_t * acmCalibrateRet(void)
{
    return aAcmCalibrateState;
}

ACM_State_e * acmStateRet(void)
{
    return &eACMState;
}
// these two functions are for acw part.
uint16_t acwCanGetAddress_1(void)
{
    return (uint16_t)ACW_CAN_ADDRESS_1;
}
uint16_t acwCanGetAddress_2(void)
{
    return (uint16_t)ACW_CAN_ADDRESS_2;
}
// get cycle and get window functions are called from C1_acw routine also, so they located in acm.c file.
// cycle is been changed in C1.
uint8_t * acwCan1GetCycle_1(void)
{
    return &iACWTTCan1Cycle_1;
}
uint8_t * acwCan1GetCycle_2(void)
{
    return &iACWTTCan1Cycle_2;
}
uint8_t * acwCan1GetWindow_1(void)
{
    return &iACWTTCan1Window_1;
}
uint8_t * acwCan1GetWindow_2(void)
{
    return &iACWTTCan1Window_2;
}
// Return a pointer to the servo data array.
ServoData *acwServoRet_1(void)
{
    return aAcwServo_1;
}

ServoData *acwServoRet_2(void)
{
    return aAcwServo_2;
}
// Return a pointer to the sensor data struct.
AcwSensorData * acwSensorRet_1(void)
{
    return &stAcwSensor_1;
}

AcwSensorData * acwSensorRet_2(void)
{
    return &stAcwSensor_2;
}

void heartbeat_mwDecrement(uint8_t iTimer)
{
    if(aHeartbeatTimer[iTimer] != 0)
        aHeartbeatTimer[iTimer]--;
    return;
}

void heartbeat_mwDecrement_acw_1(uint8_t iTimer)
{
    if(aHeartbeatTimer_acw_1[iTimer] != 0)
        aHeartbeatTimer_acw_1[iTimer]--;
	T3_OUT_acw_1[10] = aHeartbeatTimer_acw_1[iTimer];
    return;
}

void heartbeat_mwDecrement_acw_2(uint8_t iTimer)
{
    if(aHeartbeatTimer_acw_2[iTimer] != 0)
        aHeartbeatTimer_acw_2[iTimer]--;
	T3_OUT_acw_2[10] = aHeartbeatTimer_acw_2[iTimer];
    return;
}

void heartbeat_mwSet(uint8_t iTimer, uint16_t iValue)
{
    if(iTimer > HEARTBEAT_MWARE_TIMER_COUNT - 1)
        return;

    aHeartbeatTimer[iTimer] = iValue;
    return;
}

void heartbeat_mwSet_acw_1(uint8_t iTimer, uint16_t iValue)
{
    if(iTimer > HEARTBEAT_MWARE_TIMER_COUNT - 1)
        return;

    aHeartbeatTimer_acw_1[iTimer] = iValue;
    return;
}
void heartbeat_mwSet_acw_2(uint8_t iTimer, uint16_t iValue)
{
    if(iTimer > HEARTBEAT_MWARE_TIMER_COUNT - 1)
        return;

    aHeartbeatTimer_acw_2[iTimer] = iValue;
    return;
}