#include "acm.h"
#include "acwIsrC1.h"

uint8_t C1INTFbits_RBIF_ACW_1;
uint8_t C1RXFUL1bits_RXFUL1_ACW_1;       	
uint8_t C1RXFUL1bits_RXFUL2_ACW_1;
uint8_t C1RXFUL1bits_RXFUL3_ACW_1;

uint8_t C1INTFbits_RBIF_ACW_2;
uint8_t C1RXFUL1bits_RXFUL1_ACW_2;       	
uint8_t C1RXFUL1bits_RXFUL2_ACW_2;
uint8_t C1RXFUL1bits_RXFUL3_ACW_2;

uint16_t iRpm = 0;
uint16_t iTps = 0;
uint16_t iFot = 0;
uint16_t iIga = 0;

uint32_t CAN1_OUT_acw_1[12];	//output matrix
uint32_t CAN1_OUT_acw_2[12];	//output matrix

void C1_in_acw_1(uint16_t RBIF, uint16_t RXFUL1, uint16_t RXFUL2, uint16_t RXFUL3,uint32_t id,
			uint16_t *BF_ACW)
{
	int i;
	C1INTFbits_RBIF_ACW_1 = RBIF;
	C1RXFUL1bits_RXFUL1_ACW_1 = RXFUL1;
	C1RXFUL1bits_RXFUL2_ACW_1 = RXFUL2;
	C1RXFUL1bits_RXFUL3_ACW_1 = RXFUL3;
	id_acw_1 = id;

	if(C1RXFUL1bits_RXFUL1_ACW_1 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_1[1][i] = BF_ACW[i];
	}
	if(C1RXFUL1bits_RXFUL2_ACW_1 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_1[2][i] = BF_ACW[i];
	}
	if(C1RXFUL1bits_RXFUL3_ACW_1 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_1[3][i] = BF_ACW[i];
	}
}

void C1_in_acw_2(uint16_t RBIF, uint16_t RXFUL1, uint16_t RXFUL2, uint16_t RXFUL3,uint32_t id,
			uint16_t *BF_ACW)
{
	int i;
	C1INTFbits_RBIF_ACW_2 = RBIF;
	C1RXFUL1bits_RXFUL1_ACW_2 = RXFUL1;
	C1RXFUL1bits_RXFUL2_ACW_2 = RXFUL2;
	C1RXFUL1bits_RXFUL3_ACW_2 = RXFUL3;
	id_acw_2 = id;

	if(C1RXFUL1bits_RXFUL1_ACW_2 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_2[1][i] = BF_ACW[i];
	}
	if(C1RXFUL1bits_RXFUL2_ACW_2 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_2[2][i] = BF_ACW[i];
	}
	if(C1RXFUL1bits_RXFUL3_ACW_2 == 1)
	{
		for(i = 0; i < 8;i++)
			aCAN1Buffer_acw_2[3][i] = BF_ACW[i];
	}
}

void initRxbuffer_acw(void)
{
	int i,j;
	for(i = 1;i < 4;i++)
	{
		for(j = 0;j < 8;j++)
		{
			aCAN1Buffer_acw_1[i][j] = 0;
			aCAN1Buffer_acw_2[i][j] = 0;
		}
	}
}

void C1_Data_Out_acw(int n, int instance)
{
	if(instance == 1)
	{
        CAN1_OUT_acw_1[0] = aCanTableRx_acw_1[n].iId;
        CAN1_OUT_acw_1[1] = aCanTableRx_acw_1[n].bEid;
        CAN1_OUT_acw_1[2] = aCanTableRx_acw_1[n].aData[0];
        CAN1_OUT_acw_1[3] = aCanTableRx_acw_1[n].aData[1];
        CAN1_OUT_acw_1[4] = aCanTableRx_acw_1[n].aData[2];
        CAN1_OUT_acw_1[5] = aCanTableRx_acw_1[n].aData[3];
        CAN1_OUT_acw_1[6] = aCanTableRx_acw_1[n].aData[4];
        CAN1_OUT_acw_1[7] = aCanTableRx_acw_1[n].aData[5];
        CAN1_OUT_acw_1[8] = aCanTableRx_acw_1[n].aData[6];
        CAN1_OUT_acw_1[9] = aCanTableRx_acw_1[n].aData[7];
        CAN1_OUT_acw_1[10] = aCanTableRx_acw_1[n].iDlc;
        CAN1_OUT_acw_1[11] = aCanTableRx_acw_1[n].iFilter;       
	}
	if(instance == 2)
	{
        CAN1_OUT_acw_2[0] = aCanTableRx_acw_2[n].iId;
        CAN1_OUT_acw_2[1] = aCanTableRx_acw_2[n].bEid;
        CAN1_OUT_acw_2[2] = aCanTableRx_acw_2[n].aData[0];
        CAN1_OUT_acw_2[3] = aCanTableRx_acw_2[n].aData[1];
        CAN1_OUT_acw_2[4] = aCanTableRx_acw_2[n].aData[2];
        CAN1_OUT_acw_2[5] = aCanTableRx_acw_2[n].aData[3];
        CAN1_OUT_acw_2[6] = aCanTableRx_acw_2[n].aData[4];
        CAN1_OUT_acw_2[7] = aCanTableRx_acw_2[n].aData[5];
        CAN1_OUT_acw_2[8] = aCanTableRx_acw_2[n].aData[6];
        CAN1_OUT_acw_2[9] = aCanTableRx_acw_2[n].aData[7];
        CAN1_OUT_acw_2[10] = aCanTableRx_acw_2[n].iDlc;
        CAN1_OUT_acw_2[11] = aCanTableRx_acw_2[n].iFilter;
	}
}

int C1_out_acw(int n, int instance)
{
	if(instance == 1 && id_acw_1 !=0)
		return CAN1_OUT_acw_1[n];

	if(instance == 2 && id_acw_2 !=0)
		return CAN1_OUT_acw_2[n];
	else
		return 0;
}

void CanInitTableRx_1(void)
{
    CanMessage stMessage;

    // *************************************************************************
    // ACW LF Duplicate Heartbeat
    if (ACW_CAN_ADDRESS_1 == ACW_LF_CAN_ADDRESS)
	{
        canInitMessage(&stMessage);
        stMessage.iId = ACW_LF_CAN_ADDRESS;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 0);
    }

    // ACW RF Duplicate Heartbeat
    #if (ACW_CAN_ADDRESS_1 == ACW_RF_CAN_ADDRESS)
        canInitMessage(&stMessage);
        stMessage.iId = ACW_RF_CAN_ADDRESS;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 0);
    #endif

    // ACW LR Duplicate Heartbeat
    #if (ACW_CAN_ADDRESS_1 == ACW_LR_CAN_ADDRESS)
        canInitMessage(&stMessage);
        stMessage.iId = ACW_LR_CAN_ADDRESS;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 0);
    #endif

    // ACW RR Duplicate Heartbeat
    if(ACW_CAN_ADDRESS_1 == ACW_RR_CAN_ADDRESS)		//0x468
	{
        canInitMessage(&stMessage);
        stMessage.iId = ACW_RR_CAN_ADDRESS;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 0);
    }

    // *************************************************************************
    // Active Aero Control Servo Position - Front Wing
    if((ACW_CAN_ADDRESS_1 == ACW_LF_CAN_ADDRESS) || (ACW_CAN_ADDRESS_1 == ACW_RF_CAN_ADDRESS))
	{
        canInitMessage(&stMessage);
        stMessage.iId = 0x1c08;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 1);
	}

    // Active Aero Control Servo Position - Rear Wing
    if((ACW_CAN_ADDRESS_1 == ACW_LR_CAN_ADDRESS) || (ACW_CAN_ADDRESS_1 == ACW_RR_CAN_ADDRESS))
	{
        canInitMessage(&stMessage);
        stMessage.iId = 0x1c0a;

        ctSetMessage_acw_1(&stMessage, CanTable_Receive, 1);
    }

    // *************************************************************************
    // Time Trigger Sync Message
    canInitMessage(&stMessage);
    stMessage.iId = 0x3200;

    ctSetMessage_acw_1(&stMessage, CanTable_Receive, 2);

    // *************************************************************************
    // Shutdown (for aero bus)
    canInitMessage(&stMessage);
    stMessage.iId = 0x200;

    ctSetMessage_acw_1(&stMessage, CanTable_Receive, 3);

    // *************************************************************************
    // Heartbeat - Aero Master Controller
    canInitMessage(&stMessage);
    stMessage.iId = 0x460;

    ctSetMessage_acw_1(&stMessage, CanTable_Receive, 4);

    return;
}

void CanInitTableRx_2(void)
{
    CanMessage stMessage;

    // *************************************************************************
    // ACW LF Duplicate Heartbeat
    if (ACW_CAN_ADDRESS_2 == ACW_LF_CAN_ADDRESS)
	{
        canInitMessage(&stMessage);
        stMessage.iId = ACW_LF_CAN_ADDRESS;

        ctSetMessage_acw_2(&stMessage, CanTable_Receive, 0);
    }

    // ACW RF Duplicate Heartbeat
    // #if (ACW_CAN_ADDRESS_2 == ACW_RF_CAN_ADDRESS)
        // canInitMessage(&stMessage);
        // stMessage.iId = ACW_RF_CAN_ADDRESS;

        // ctSetMessage_acw_2(&stMessage, CanTable_Receive, 0);
    // #endif

    // ACW LR Duplicate Heartbeat
    // #if (ACW_CAN_ADDRESS_2 == ACW_LR_CAN_ADDRESS)
        // canInitMessage(&stMessage);
        // stMessage.iId = ACW_LR_CAN_ADDRESS;

        // ctSetMessage_acw_2(&stMessage, CanTable_Receive, 0);
    // #endif

    // ACW RR Duplicate Heartbeat
    if(ACW_CAN_ADDRESS_2 == ACW_RR_CAN_ADDRESS)		//0x468
	{
        canInitMessage(&stMessage);
        stMessage.iId = ACW_RR_CAN_ADDRESS;

        ctSetMessage_acw_2(&stMessage, CanTable_Receive, 0);
    }

    // *************************************************************************
    // Active Aero Control Servo Position - Front Wing
    if((ACW_CAN_ADDRESS_2 == ACW_LF_CAN_ADDRESS) || (ACW_CAN_ADDRESS_2 == ACW_RF_CAN_ADDRESS))
	{
        canInitMessage(&stMessage);
        stMessage.iId = 0x1c08;

        ctSetMessage_acw_2(&stMessage, CanTable_Receive, 1);
	}

    // Active Aero Control Servo Position - Rear Wing
    if((ACW_CAN_ADDRESS_2 == ACW_LR_CAN_ADDRESS) || (ACW_CAN_ADDRESS_2 == ACW_RR_CAN_ADDRESS))
	{
        canInitMessage(&stMessage);
        stMessage.iId = 0x1c0a;

        ctSetMessage_acw_2(&stMessage, CanTable_Receive, 1);
    }

    // *************************************************************************
    // Time Trigger Sync Message
    canInitMessage(&stMessage);
    stMessage.iId = 0x3200;

    ctSetMessage_acw_2(&stMessage, CanTable_Receive, 2);

    // *************************************************************************
    // Shutdown (for aero bus)
    canInitMessage(&stMessage);
    stMessage.iId = 0x200;

    ctSetMessage_acw_2(&stMessage, CanTable_Receive, 3);

    // *************************************************************************
    // Heartbeat - Aero Master Controller
    canInitMessage(&stMessage);
    stMessage.iId = 0x460;

    ctSetMessage_acw_2(&stMessage, CanTable_Receive, 4);

    return;
}

void acwTimer1Start_1(void)
{
	acwtimer_1 = 1;
}

void acwTimer1Start_2(void)
{
	acwtimer_2 = 1;
}

void datatransform(CanMessage * stMessage)
{
    stMessage->bReading = 1;

    // *************************************************************************
    // Read RPM
    iRpm = stMessage->aData[1];
    iRpm <<= 8;
    iRpm |= stMessage->aData[0];

    // *************************************************************************
    // Read TPS
    iTps = stMessage->aData[3];
    iTps <<= 8;
    iTps |= stMessage->aData[2];
    iTps /= 10;

    // *************************************************************************
    // Read Fuel Open Time
    iFot = stMessage->aData[5];
    iFot <<= 8;
    iFot |= stMessage->aData[4];
    iFot /= 10;

    // *************************************************************************
    // Read Ignition angle
    iIga = stMessage->aData[7];
    iIga <<= 8;
    iIga |= stMessage->aData[6];
    iIga /= 10;

    stMessage->bReading = 0;

    return;
}

void acwIsrC1_1(void)
{
    #ifdef ENABLE_MODULE_ECAN_1

    uint8_t * iCan1CycleIndex = acwCan1GetCycle_1();
    uint8_t * iCan1WindowIndex = acwCan1GetWindow_1();
    uint16_t iCanTableIndex = 0;

    CanMessage stMessage;

    if(C1INTFbits_RBIF_ACW_1)
    {
        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 1 = RX buffer 0

        if(C1RXFUL1bits_RXFUL1_ACW_1)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(1, &stMessage);
			directRxMessage_acw_1(1, &stMessage);
			C1RXFUL1bits_RXFUL1_ACW_1 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_1(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_1(&stMessage, CanTable_Receive, iCanTableIndex);
        }

        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 2 = RX buffer 1

        if(C1RXFUL1bits_RXFUL2_ACW_1)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(2, &stMessage);
			directRxMessage_acw_1(2, &stMessage);
			C1RXFUL1bits_RXFUL2_ACW_1 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_1(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_1(&stMessage, CanTable_Receive, iCanTableIndex);
        }

        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 3 = RX buffer 2

        if(C1RXFUL1bits_RXFUL3_ACW_1)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(3, &stMessage);
			directRxMessage_acw_1(3, &stMessage);
			C1RXFUL1bits_RXFUL3_ACW_1 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_1(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_1(&stMessage, CanTable_Receive, iCanTableIndex);
        }
		C1_Data_Out_acw(iCanTableIndex,1);
        // ********************************************************************
        // Check for a TTCAN sync message
        if(stMessage.iId == 0x3200)
        {
            // Store the TTCAN cycle index
            *iCan1CycleIndex = stMessage.aData[0];

            // The TTCAN sync message takes up window 0, listeners should skip.
            (*iCan1WindowIndex) = 1;

            // Start the TTCAN window timer.
            acwTimer1Start_1();
        }

        // Clear ECAN module TX interrupt flag
        // C1INTFbits.RBIF = 0;
		C1INTFbits_RBIF_ACW_1 = 0;
    }
    // else if(C1INTFbits.TBIF)
    // {
        // Clear ECAN module TX interrupt flag
        // C1INTFbits.TBIF = 0;
    // }
    else;

    #endif

    return;
}

void acwIsrC1_2(void)
{
    #ifdef ENABLE_MODULE_ECAN_1

    uint8_t * iCan1CycleIndex = acwCan1GetCycle_2();
    uint8_t * iCan1WindowIndex = acwCan1GetWindow_2();
    uint16_t iCanTableIndex = 0;

    CanMessage stMessage;

    if(C1INTFbits_RBIF_ACW_2)
    {
        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 1 = RX buffer 0

        if(C1RXFUL1bits_RXFUL1_ACW_2)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(1, &stMessage);
			directRxMessage_acw_2(1, &stMessage);
			C1RXFUL1bits_RXFUL1_ACW_2 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_2(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_2(&stMessage, CanTable_Receive, iCanTableIndex);
        }

        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 2 = RX buffer 1

        if(C1RXFUL1bits_RXFUL2_ACW_2)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(2, &stMessage);
			directRxMessage_acw_2(2, &stMessage);
			C1RXFUL1bits_RXFUL2_ACW_2 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_2(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_2(&stMessage, CanTable_Receive, iCanTableIndex);
        }

        // ********************************************************************
        // Process Extended ID messages from ECAN buffer 3 = RX buffer 2

        if(C1RXFUL1bits_RXFUL3_ACW_2)
        {
            canInitMessage(&stMessage);
            // can1RxMessage_acw(3, &stMessage);
			directRxMessage_acw_2(3, &stMessage);
			C1RXFUL1bits_RXFUL3_ACW_2 = 0;
            // Store this message in the CAN message table
            iCanTableIndex = ctGetMessageIndex_acw_2(CanTable_Receive, stMessage.iId);
            ctSetMessage_acw_2(&stMessage, CanTable_Receive, iCanTableIndex);
        }
		C1_Data_Out_acw(iCanTableIndex,2);
        // ********************************************************************
        // Check for a TTCAN sync message
        if(stMessage.iId == 0x3200)
        {
            // Store the TTCAN cycle index
            *iCan1CycleIndex = stMessage.aData[0];

            // The TTCAN sync message takes up window 0, listeners should skip.
            (*iCan1WindowIndex) = 1;

            // Start the TTCAN window timer.
            acwTimer1Start_2();
        }

        // Clear ECAN module TX interrupt flag
        // C1INTFbits.RBIF = 0;
		C1INTFbits_RBIF_ACW_2 = 0;
    }
    // else if(C1INTFbits.TBIF)
    // {
        // Clear ECAN module TX interrupt flag
        // C1INTFbits.TBIF = 0;
    // }
    else;

    #endif

    return;
}