#include "acm.h"
#include "acwIsrT3.h"

void heartbeat_mwInit(void)
{
	aHeartbeatTimer[0] = 50;
	aHeartbeatTimer_acw_1[0] = 50;
	aHeartbeatTimer_acw_2[0] = 50;
}

void acwCanInputServoRR_1(void)
{
    ServoData * aAcwServo_1 = acwServoRet_1();
    AcwSensorData * stAcwSensor = acwSensorRet_1();
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x0);

    uint8_t bEnabled = 0;
    uint8_t bInvert = 0;
    uint8_t bMoving = 0;
    uint8_t bPowered = 0;

    uint16_t iPosLower = 0;
    uint16_t iPosUpper = 0;

    stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x1c0a);

    if(stMessage->bPending == 1)
    {
        // Unpack data for the lower servo.
        iPosLower = stMessage->aData[4];
        iPosLower <<= 8;
        iPosLower |= stMessage->aData[5];
        iPosLower &= 0xfff;

        bEnabled = stMessage->aData[4];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[4];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[4];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[4];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosLower = iPosLower;        

        aAcwServo_1[ACW_SERVO_LOWER].bEnabled = bEnabled;
        aAcwServo_1[ACW_SERVO_LOWER].bInvert = bInvert;
        aAcwServo_1[ACW_SERVO_LOWER].bMoving = bMoving;
        aAcwServo_1[ACW_SERVO_LOWER].bPowered = bPowered;   
		
		T3_OUT_acw_1[0] = iPosLower;
		T3_OUT_acw_1[1] = bEnabled;
		T3_OUT_acw_1[2] = bInvert;
		T3_OUT_acw_1[3] = bMoving;
		T3_OUT_acw_1[4] = bPowered;
	
	
        // Unpack data for the upper servo.
        iPosUpper = stMessage->aData[6];
        iPosUpper <<= 8;
        iPosUpper |= stMessage->aData[7];
        iPosUpper &= 0xfff;

        bEnabled = stMessage->aData[6];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[6];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[6];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[6];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosUpper = iPosUpper;        

        aAcwServo_1[ACW_SERVO_UPPER].bEnabled = bEnabled;
        aAcwServo_1[ACW_SERVO_UPPER].bInvert = bInvert;
        aAcwServo_1[ACW_SERVO_UPPER].bMoving = bMoving;
        aAcwServo_1[ACW_SERVO_UPPER].bPowered = bPowered;
		
		T3_OUT_acw_1[5] = iPosUpper;
		T3_OUT_acw_1[6] = bEnabled;
		T3_OUT_acw_1[7] = bInvert;
		T3_OUT_acw_1[8] = bMoving;
		T3_OUT_acw_1[9] = bPowered;

        stMessage->bReading = 0;
        stMessage->bPending = 0;
    }


    return;
}

void acwCanInputServoRR_2(void)
{
    ServoData * aAcwServo_2 = acwServoRet_2();
    AcwSensorData * stAcwSensor = acwSensorRet_2();
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x0);

    uint8_t bEnabled = 0;
    uint8_t bInvert = 0;
    uint8_t bMoving = 0;
    uint8_t bPowered = 0;

    uint16_t iPosLower = 0;
    uint16_t iPosUpper = 0;

    stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x1c0a);

    if(stMessage->bPending == 1)
    {
        // Unpack data for the lower servo.
        iPosLower = stMessage->aData[4];
        iPosLower <<= 8;
        iPosLower |= stMessage->aData[5];
        iPosLower &= 0xfff;

        bEnabled = stMessage->aData[4];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[4];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[4];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[4];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosLower = iPosLower;        

        aAcwServo_2[ACW_SERVO_LOWER].bEnabled = bEnabled;
        aAcwServo_2[ACW_SERVO_LOWER].bInvert = bInvert;
        aAcwServo_2[ACW_SERVO_LOWER].bMoving = bMoving;
        aAcwServo_2[ACW_SERVO_LOWER].bPowered = bPowered;   
		
		T3_OUT_acw_2[0] = iPosLower;
		T3_OUT_acw_2[1] = bEnabled;
		T3_OUT_acw_2[2] = bInvert;
		T3_OUT_acw_2[3] = bMoving;
		T3_OUT_acw_2[4] = bPowered;
	
	
        // Unpack data for the upper servo.
        iPosUpper = stMessage->aData[6];
        iPosUpper <<= 8;
        iPosUpper |= stMessage->aData[7];
        iPosUpper &= 0xfff;

        bEnabled = stMessage->aData[6];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[6];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[6];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[6];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosUpper = iPosUpper;        

        aAcwServo_2[ACW_SERVO_UPPER].bEnabled = bEnabled;
        aAcwServo_2[ACW_SERVO_UPPER].bInvert = bInvert;
        aAcwServo_2[ACW_SERVO_UPPER].bMoving = bMoving;
        aAcwServo_2[ACW_SERVO_UPPER].bPowered = bPowered;
		
		T3_OUT_acw_2[5] = iPosUpper;
		T3_OUT_acw_2[6] = bEnabled;
		T3_OUT_acw_2[7] = bInvert;
		T3_OUT_acw_2[8] = bMoving;
		T3_OUT_acw_2[9] = bPowered;

        stMessage->bReading = 0;
        stMessage->bPending = 0;
    }


    return;
}

void acwCanInputServoLF_1(void)
{
    ServoData * aAcwServo_1 = acwServoRet_1();
    AcwSensorData * stAcwSensor = acwSensorRet_1();
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x0);

    uint8_t bEnabled = 0;
    uint8_t bInvert = 0;
    uint8_t bMoving = 0;
    uint8_t bPowered = 0;
    
    uint16_t iPosLower = 0;
    uint16_t iPosUpper = 0;

    stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x1c08);

    if(stMessage->bPending == 1 && stMessage->bWriting == 0)
    {
        stMessage->bReading = 1;

        // Unpack data for the lower servo.
        iPosLower = stMessage->aData[0];
        iPosLower <<= 8;
        iPosLower |= stMessage->aData[1];
        iPosLower &= 0xfff;

        bEnabled = stMessage->aData[0];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[0];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[0];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[0];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosLower = iPosLower;        

        aAcwServo_1[ACW_SERVO_LOWER].bEnabled = bEnabled;        
        aAcwServo_1[ACW_SERVO_LOWER].bInvert = bInvert;
        aAcwServo_1[ACW_SERVO_LOWER].bMoving = bMoving;
        aAcwServo_1[ACW_SERVO_LOWER].bPowered = bPowered;    

		T3_OUT_acw_1[0] = iPosLower;
		T3_OUT_acw_1[1] = bEnabled;
		T3_OUT_acw_1[2] = bInvert;
		T3_OUT_acw_1[3] = bMoving;
		T3_OUT_acw_1[4] = bPowered;
		
        // Unpack data for the upper servo.
        iPosUpper = stMessage->aData[2];
        iPosUpper <<= 8;
        iPosUpper |= stMessage->aData[3];
        iPosUpper &= 0xfff;

        bEnabled = stMessage->aData[2];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[2];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[2];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[2];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosUpper = iPosUpper;        

        aAcwServo_1[ACW_SERVO_UPPER].bEnabled = bEnabled;        
        aAcwServo_1[ACW_SERVO_UPPER].bInvert = bInvert;
        aAcwServo_1[ACW_SERVO_UPPER].bMoving = bMoving;
        aAcwServo_1[ACW_SERVO_UPPER].bPowered = bPowered;    

		T3_OUT_acw_1[5] = iPosUpper;
		T3_OUT_acw_1[6] = bEnabled;
		T3_OUT_acw_1[7] = bInvert;
		T3_OUT_acw_1[8] = bMoving;
		T3_OUT_acw_1[9] = bPowered;

        stMessage->bReading = 0;
        stMessage->bPending = 0;
    }

    return;
}

void acwCanInputServoLF_2(void)
{
    ServoData * aAcwServo_2 = acwServoRet_2();
    AcwSensorData * stAcwSensor = acwSensorRet_2();
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x0);

    uint8_t bEnabled = 0;
    uint8_t bInvert = 0;
    uint8_t bMoving = 0;
    uint8_t bPowered = 0;
    
    uint16_t iPosLower = 0;
    uint16_t iPosUpper = 0;

    stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x1c08);

    if(stMessage->bPending == 1 && stMessage->bWriting == 0)
    {
        stMessage->bReading = 1;

        // Unpack data for the lower servo.
        iPosLower = stMessage->aData[0];
        iPosLower <<= 8;
        iPosLower |= stMessage->aData[1];
        iPosLower &= 0xfff;

        bEnabled = stMessage->aData[0];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[0];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[0];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[0];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosLower = iPosLower;        

        aAcwServo_2[ACW_SERVO_LOWER].bEnabled = bEnabled;        
        aAcwServo_2[ACW_SERVO_LOWER].bInvert = bInvert;
        aAcwServo_2[ACW_SERVO_LOWER].bMoving = bMoving;
        aAcwServo_2[ACW_SERVO_LOWER].bPowered = bPowered;    

		T3_OUT_acw_2[0] = iPosLower;
		T3_OUT_acw_2[1] = bEnabled;
		T3_OUT_acw_2[2] = bInvert;
		T3_OUT_acw_2[3] = bMoving;
		T3_OUT_acw_2[4] = bPowered;
		
        // Unpack data for the upper servo.
        iPosUpper = stMessage->aData[2];
        iPosUpper <<= 8;
        iPosUpper |= stMessage->aData[3];
        iPosUpper &= 0xfff;

        bEnabled = stMessage->aData[2];
        bEnabled >>= 4;
        bEnabled &= 0x01;

        bInvert = stMessage->aData[2];
        bInvert >>= 5;
        bInvert &= 0x01;

        bMoving = stMessage->aData[2];
        bMoving >>= 6;
        bMoving &= 0x01;

        bPowered = stMessage->aData[2];
        bPowered >>= 7;
        bPowered &= 0x01;
        
        stAcwSensor->iPosUpper = iPosUpper;        

        aAcwServo_2[ACW_SERVO_UPPER].bEnabled = bEnabled;        
        aAcwServo_2[ACW_SERVO_UPPER].bInvert = bInvert;
        aAcwServo_2[ACW_SERVO_UPPER].bMoving = bMoving;
        aAcwServo_2[ACW_SERVO_UPPER].bPowered = bPowered;    

		T3_OUT_acw_2[5] = iPosUpper;
		T3_OUT_acw_2[6] = bEnabled;
		T3_OUT_acw_2[7] = bInvert;
		T3_OUT_acw_2[8] = bMoving;
		T3_OUT_acw_2[9] = bPowered;

        stMessage->bReading = 0;
        stMessage->bPending = 0;
    }

    return;
}

void acwCanInputDuplicateHb_1(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_1();
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Receive, ACW_CAN_ADDRESS_1);

    if(stMessage->iId == ACW_CAN_ADDRESS_1)
    {
        if(stMessage->bPending == 1 && stMessage->bWriting == 0)
        {
            stAcwSensor->bDuplicateHb = 1;
            stMessage->bPending = 0;
        }
    }

    return;
}

void acwCanInputDuplicateHb_2(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_2();
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Receive, ACW_CAN_ADDRESS_2);

    if(stMessage->iId == ACW_CAN_ADDRESS_2)
    {
        if(stMessage->bPending == 1 && stMessage->bWriting == 0)
        {
            stAcwSensor->bDuplicateHb = 1;
            stMessage->bPending = 0;
        }
    }

    return;
}

// Reset the heartbeat timers.
void acwCanInputHeartbeat_1(void)
{
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x0);

    // *************************************************************************
    // Aero Control Master
    stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x460);

    if(stMessage->bPending == 1 && stMessage->bWriting == 0)
    {
        heartbeat_mwSet_acw_1(ACW_HEARTBEAT_TIMER_ACM, ACW_HEARTBEAT_TIMEOUT_MULTIPLIER);
        stMessage->bPending = 0;
    }

    return;
}

void acwCanInputHeartbeat_2(void)
{
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x0);

    // *************************************************************************
    // Aero Control Master
    stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x460);

    if(stMessage->bPending == 1 && stMessage->bWriting == 0)
    {
        heartbeat_mwSet_acw_2(ACW_HEARTBEAT_TIMER_ACM, ACW_HEARTBEAT_TIMEOUT_MULTIPLIER);
        stMessage->bPending = 0;
    }

    return;
}

void acwCanInputServo_1(void)
{
    if (ACW_CAN_ADDRESS_1 == ACW_LF_CAN_ADDRESS)
        acwCanInputServoLF_1();

    // #if (ACW_CAN_ADDRESS_1 == ACW_LR_CAN_ADDRESS)
        // acwCanInputServoLR();
    // #endif

    // #if (ACW_CAN_ADDRESS_1 == ACW_RF_CAN_ADDRESS)
        // acwCanInputServoRF();
    // #endif

    if (ACW_CAN_ADDRESS_1 == ACW_RR_CAN_ADDRESS)			// this one is active
        acwCanInputServoRR_1();

    return;
}

void acwCanInputServo_2(void)
{
    if (ACW_CAN_ADDRESS_2 == ACW_LF_CAN_ADDRESS)
        acwCanInputServoLF_2();

    // #if (ACW_CAN_ADDRESS_2 == ACW_LR_CAN_ADDRESS)
        // acwCanInputServoLR();
    // #endif

    // #if (ACW_CAN_ADDRESS_2 == ACW_RF_CAN_ADDRESS)
        // acwCanInputServoRF();
    // #endif

    if (ACW_CAN_ADDRESS_2 == ACW_RR_CAN_ADDRESS)			// this one is active
        acwCanInputServoRR_2();

    return;
}

void acwCanInputShutdown_1(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_1();
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Receive, 0x200);

    if(stMessage->bPending == 1)
    {
        if(stMessage->aData[0] != 0xa5)
            return;

        stAcwSensor->bShutdown = 1;
        stMessage->bPending = 0;
    }

    return;
}

void acwCanInputShutdown_2(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_2();
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Receive, 0x200);

    if(stMessage->bPending == 1)
    {
        if(stMessage->aData[0] != 0xa5)
            return;

        stAcwSensor->bShutdown = 1;
        stMessage->bPending = 0;
    }

    return;
}

void acwCanOutputSwLimit_1(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_1();
    CanMessage * stMessage = ctGetMessageById_acw_1(CanTable_Transmit, 0x0);    
    
    if(ACW_CAN_ADDRESS_1 == ACW_LF_CAN_ADDRESS)
        stMessage = ctGetMessageById_acw_1(CanTable_Transmit, 0x1e00);

    // #if (ACW_CAN_ADDRESS_1 == ACW_RF_CAN_ADDRESS)
        // stMessage = ctGetMessageById_acw_1(CanTable_Transmit, 0x1e02);
    // #endif

    // #if (ACW_CAN_ADDRESS_1 == ACW_LR_CAN_ADDRESS)
        // stMessage = ctGetMessageById_acw_1(CanTable_Transmit, 0x1e04);
    // #endif

    if(ACW_CAN_ADDRESS_1 == ACW_RR_CAN_ADDRESS)
        stMessage = ctGetMessageById_acw_1(CanTable_Transmit, 0x1e06);

    stMessage->bWriting = 1;

    stMessage->aData[0] = 255;			// stAcwSensor->iSwLimit;

    stMessage->bWriting = 0;

    return;
}

void acwCanOutputSwLimit_2(void)
{
    AcwSensorData * stAcwSensor = acwSensorRet_2();
    CanMessage * stMessage = ctGetMessageById_acw_2(CanTable_Transmit, 0x0);    
    
    if(ACW_CAN_ADDRESS_2 == ACW_LF_CAN_ADDRESS)
        stMessage = ctGetMessageById_acw_2(CanTable_Transmit, 0x1e00);

    // #if (ACW_CAN_ADDRESS_2 == ACW_RF_CAN_ADDRESS)
        // stMessage = ctGetMessageById_acw_2(CanTable_Transmit, 0x1e02);
    // #endif

    // #if (ACW_CAN_ADDRESS_2 == ACW_LR_CAN_ADDRESS)
        // stMessage = ctGetMessageById_acw_2(CanTable_Transmit, 0x1e04);
    // #endif

    if(ACW_CAN_ADDRESS_2 == ACW_RR_CAN_ADDRESS)
        stMessage = ctGetMessageById_acw_2(CanTable_Transmit, 0x1e06);

    stMessage->bWriting = 1;

    stMessage->aData[0] = 30;			// stAcwSensor->iSwLimit;

    stMessage->bWriting = 0;

    return;
}

void acwIsrT3_1(void)
{
    // Sensor Input
    // acwSensorInputSwLimit();

    // CAN Input
    acwCanInputDuplicateHb_1();
    acwCanInputHeartbeat_1();
    acwCanInputServo_1();
    acwCanInputShutdown_1();

    // CAN Output
    acwCanOutputSwLimit_1();			// depand on acwSensorInputSwLimit(), but it's a H/W operation, so
									// basically no effect but I put a random number here.

    // Heartbeat Monitoring
    heartbeat_mwDecrement_acw_1(ACW_HEARTBEAT_TIMER_ACM);

    // Control Output
    // acwServoMove();
    return;
}

void acwIsrT3_2(void)
{
    acwCanInputDuplicateHb_2();
    acwCanInputHeartbeat_2();
    acwCanInputServo_2();
    acwCanInputShutdown_2();
    acwCanOutputSwLimit_2();
    heartbeat_mwDecrement_acw_2(ACW_HEARTBEAT_TIMER_ACM);
    return;
}

void T3_Data_Out_acw_1(void)		//unecessary, process done else where. just search it.
{
    // ServoData * aAcwServo = acwServoRet();
    // AcwSensorData * stAcwSensor = acwSensorRet();	
	T3_OUT_acw_1[0] = stAcwSensor_1.iPosLower;
	T3_OUT_acw_1[1] = aAcwServo_1[ACW_SERVO_LOWER].bEnabled;
	T3_OUT_acw_1[2] = aAcwServo_1[ACW_SERVO_LOWER].bInvert;
	T3_OUT_acw_1[3] = aAcwServo_1[ACW_SERVO_LOWER].bMoving;
	T3_OUT_acw_1[4] = aAcwServo_1[ACW_SERVO_LOWER].bPowered;
	T3_OUT_acw_1[5] = stAcwSensor_1.iPosUpper;
	T3_OUT_acw_1[6] = aAcwServo_1[ACW_SERVO_UPPER].bEnabled;
	T3_OUT_acw_1[7] = aAcwServo_1[ACW_SERVO_UPPER].bInvert;
	T3_OUT_acw_1[8] = aAcwServo_1[ACW_SERVO_UPPER].bMoving;
	T3_OUT_acw_1[9] = aAcwServo_1[ACW_SERVO_UPPER].bPowered;
	T3_OUT_acw_1[10] = aHeartbeatTimer_acw_1[ACW_HEARTBEAT_TIMER_ACM];
}

void T3_Data_Out_acw_2(void)		//unecessary, process done else where. just search it.
{
    // ServoData * aAcwServo_2 = acwServoRet();
    // AcwSensorData * stAcwSensor = acwSensorRet();	
	T3_OUT_acw_2[0] = stAcwSensor_2.iPosLower;
	T3_OUT_acw_2[1] = aAcwServo_2[ACW_SERVO_LOWER].bEnabled;
	T3_OUT_acw_2[2] = aAcwServo_2[ACW_SERVO_LOWER].bInvert;
	T3_OUT_acw_2[3] = aAcwServo_2[ACW_SERVO_LOWER].bMoving;
	T3_OUT_acw_2[4] = aAcwServo_2[ACW_SERVO_LOWER].bPowered;
	T3_OUT_acw_2[5] = stAcwSensor_2.iPosUpper;
	T3_OUT_acw_2[6] = aAcwServo_2[ACW_SERVO_UPPER].bEnabled;
	T3_OUT_acw_2[7] = aAcwServo_2[ACW_SERVO_UPPER].bInvert;
	T3_OUT_acw_2[8] = aAcwServo_2[ACW_SERVO_UPPER].bMoving;
	T3_OUT_acw_2[9] = aAcwServo_2[ACW_SERVO_UPPER].bPowered;
	T3_OUT_acw_2[10] = aHeartbeatTimer_acw_2[ACW_HEARTBEAT_TIMER_ACM];
}
int T3_out_acw(int n,int instance)
{
	if(instance == 1)
		return T3_OUT_acw_1[n];
	if(instance == 2)
		return T3_OUT_acw_2[n];
	return 0;
}
